Function _SEEK
Lparameters _value
Local m.r
If Seek(_value)
	Skip
	If Eof()
		m.r=.t.
		Skip -1
	Else 
		If Rtrim(Upper(name))==_value
			m.r=.f.
		Else
			m.r=.t.
		EndIf 
		Skip -1
		If m.r and !(Rtrim(Upper(name))==_value)
			m.r=.f.
		EndIf 
	EndIf 	
Else 
	m.r=.f.
EndIf 
If !m.r &&and Empty(_value)
	Go bottom 
	If !Eof()
		Skip 
	EndIf 
EndIf 
Return m.r

DEFINE CLASS my_Grid as Grid
	ReadOnly = .t.
	DeleteMark = .f.
	ScrollBars = 3
	Height = 200
	Width = 30
	CurrentOrder = 999
	memRowHeight = this.RowHeight 
	GridRec = Recno()
	Visible = .t.

	PROCEDURE AfterRowColChange
		LPARAMETERS nColIndex
		this.GridRec = RECNO()
		thisform.navigator.go_skip
		If Type('this.Columns(nColIndex).Text1.Text1')='O'
			NoDefault
			this.Columns(nColIndex).Text1.Text1.SetFocus
		EndIf 
	ENDPROC 	
	
*!*		PROCEDURE Refresh
*!*			Local lcOrder, lnOrder
*!*			With This
*!*				Select (.RecordSource)
*!*				lnOrder = Val(Sys(21))
*!*				If .CurrentOrder # m.lnOrder
*!*					lcOrder = Iif(m.lnOrder = 0,'1',Key(m.lnOrder))
*!*					Select Recno() As RcNo, &lcOrder As OrderCol ;
*!*						from (.RecordSource) ;
*!*						order By OrderCol  ;
*!*						into Cursor crsOrdering ;
*!*						readwrite
*!*					Select crsOrdering
*!*					Index On RcNo Tag RcNo
*!*					Select (.RecordSource)
*!*					.CurrentOrder = m.lnOrder
*!*				Endif
*!*			Endwith	
*!*		ENDPROC 
	
	Procedure ResizeTxtCmd
	Local m.c
		For each m.c in this.Columns 
			If Upper(m.c.Text1.Class) = 'TXTCMD'
				If m.c.Width<30
					m.c.Width = 30
				EndIf 			
				m.c.text1.text1.Width= m.c.Width - 20 
				m.c.text1.command1.Left = m.c.Width - 20 
				m.c.text1.text1.height=this.RowHeight
				m.c.text1.command1.height=this.RowHeight
				m.c.refresh
			EndIf 
		EndFor 				
	EndProc 

	Procedure MouseUp
	LPARAMETERS nButton, nShift, nXCoord, nYCoord
		If this.RowHeight#this.memRowHeight
			this.memRowHeight = this.RowHeight
			this.ResizeTxtCmd()
		EndIf 		
	EndProc
	
	Procedure Resize
		this.ResizeTxtCmd()
	EndProc 
	
ENDDEFINE 

Define Class my_Check as CheckBox
	BorderStyle = 0
	Margin = 0
	Caption = ''
	Visible = .t.
EndDefine 

DEFINE CLASS my_Text as TextBox 
	BorderStyle = 0
	Margin = 0
	Visible = .t.
	
	PROCEDURE DblClick
		thisform.navigator.cOk.Click
	ENDPROC 
	
	PROCEDURE KeyPress
		LPARAMETERS nKeyCode, nShiftAltCtrl
*WAIT WINDOW TRANSFORM(nKeyCode) + ' '+TRANSFORM( nShiftAltCtrl)&& NOWAIT 

		DO case 
		Case nKeyCode=31 and nShiftAltCtrl=2 && Ctrl+PgUp
			thisform.navigator.cFirstRec.click 
		Case nKeyCode=30 and nShiftAltCtrl=2 && Ctrl+PgDn
			thisform.navigator.cLastRec.click 
		Case nKeyCode=-6 OR (nShiftAltCtrl=2 AND nKeyCode=6) && F7  Ctrl+F ()
			NODEFAULT 
			If this.parent.name='Text1'
				If !this.parent.parent.Header1.FontBold
					this.Parent.parent.Header1.dblClick
				EndIf 
				thisform.tFind.SetFocus(this.parent)							
			Else 
				If !this.parent.Header1.FontBold
					this.Parent.Header1.dblClick
				EndIf 
				thisform.tFind.SetFocus(this)			
			EndIf 
		Case nShiftAltCtrl=2 AND nKeyCode=7 && Ctrl+G ( )
			NODEFAULT 
			WITH thisform.tFind
				IF !EMPTY(.Field) AND ;
				.Field = Iif(this.parent.name='Text1',this.Parent.Parent.ControlSource,this.Parent.ControlSource ) AND;
				!EMPTY(.value)
					.ogRec.value = 2
					.tFind.Value = .value
					.tFind.KeyPress(13)
				ENDIF 
			ENDWITH 
		Case nShiftAltCtrl=2 and nKeyCode=10	&& Ctrl+Enter ()
			thisform.navigator.cOk.Click
		EndCase 

	ENDPROC 

	Procedure MouseDown 
	LPARAMETERS nButton, nShift, nXCoord, nYCoord
		If nButton=2 and nShift=0 and this.ReadOnly = .f.	&& RightClick   -  
			If Type(this.ControlSource)='D'
			Local _date
				DO FORM f_SetDate WITH this.Value TO _date
				replace (this.ControlSource) WITH _date				
			EndIf 				
		EndIf 
	EndProc 	
ENDDEFINE 

DEFINE CLASS my_Header as Header
	Alignment = 2
	WordWrap = .t.

	PROCEDURE MouseDown
	LPARAMETERS nButton, nShift, nXCoord, nYCoord
		IF nButton=2 &&RightClick - ,   
			LOCAL _x,_y
			_x=OBJTOCLIENT(this,2)/FONTMETRIC(6)
			_y=OBJTOCLIENT(this,1)
			DEFINE POPUP popHeader FROM _y,_x ;
			   MULTISELECT MARGIN				&& Create multi-choice menu
			DEFINE BAR 1 OF popHeader;
			   PROMPT '\<1  '  MARK CHR(3)	&& First item
			DEFINE BAR 2 OF popHeader;
			   PROMPT '\<2  ' MARK CHR(4)	&& Second item
			DEFINE BAR 3 OF popHeader;
			   PROMPT '\<3  '  MARK CHR(5) && Third item
			DEFINE BAR 4 OF popHeader;
			   PROMPT '\<4  '  MARK CHR(6)	&& Fourth item			
			ON SELECTION POPUP popHeader DO popHeaderChoices	&& Choice routine
			ACTIVATE POPUP popHeader
		ENDIF 

	ENDPROC 
	
	PROCEDURE dblClick
		LOCAL m.c,_alias,_field,_rec
		thisform.tFind.Comment = ''
		For each m.c in this.Parent.parent.Columns
			If this.Parent.Name#m.c.name
				m.c.Header1.FontBold = .f.
			EndIf 
		ENDFOR 
		
		_alias = thisform.GKLS.RecordSource
		_field = SUBSTR(this.Parent.Name,2)
		_rec=RECNO(_alias)
		Select (_alias)
		IF TAGNO(_field)>0 &&   
			thisform.tFind.Comment = '*'
			
			If this.FontBold=.t.
				If Descending()
					SET ORDER TO &_field ascending 
				Else
					SET ORDER TO &_field descending
				EndIf 
			Else 
				SET ORDER TO &_field
				this.FontBold = .t.
			EndIf 
			
			thisform.gKLS.refresh
			=_GoTo(_rec)
			thisform.gKLS.SetFocus
		Else		 		
			If ISEXCLUSIVE(_alias) and MESSAGEBOX('    '+Chr(13)+'  ',' ',36+256)=6
				LOCAL _dbf,_path,_c
				thisform.tFind.Comment = '*'
				=_GoTo(_rec)
*				_dbf=JUSTSTEM(DBF())
*				_path=JUSTPATH(DBF())+'\'
*				IF _use(_dbf,_path,'',.t.)
					_c='INDEX ON '+_field+' TAG '+_field+' ADDITIVE'
					&_c
*					_use(_dbf,_path,_field)
*				ENDIF 			
*				thisform.Init(_dbf,_path)
				this.FontBold=.t.
			Else 
				replace tKLS0.order with ''
			EndIf  
		ENDIF		
	ENDPROC 
	
ENDDEFINE 

DEFINE CLASS my_Column as Column
	Visible = .t.
	mem_Width = 0
	PROCEDURE Init 
		this.RemoveObject('Header1')
		this.RemoveObject('Text1')

		this.AddObject('Header1','my_Header')
		
		DO case 		
		Case tKLS.Type=2 or tKLS.Type=3
			this.Sparse=.f.	
			this.Name = 'c'+RTRIM(SUBSTR(tKLS.KLS_Field,AT('.',tKLS.KLS_Field)+1))
			this.AddObject('Text1','TxtCmd')
			this.Text1.Text1.FontSize = tKLS0.FontSize
			this.Text1.Text1.ControlSource=ALLTRIM(tKLS.Control)
			this.resize 
			StrToFile(Alltrim(tKLS.Command),'comm'+this.Name+'.prg')
			Compile ('comm'+this.Name+'.prg')
			
		Case Type(tKLS.Control)='L'
			this.Sparse = .f.
			this.AddObject('Text1','my_Check')			

		Otherwise  
			this.AddObject('Text1','my_Text')		
		EndCase 		
		
	ENDPROC 
	
	PROCEDURE Resize
		LOCAL m.c,m.w
		m.w=0
		this.mem_Width = this.Width 
		For each m.c in this.Parent.Columns
			m.w=m.w+m.c.Width+1
		ENDFOR 
		IF (m.w+30)>this.Parent.Width
			this.Parent.ScrollBars = 3
		ELSE 
			this.Parent.ScrollBars = 2
		ENDIF 	
		this.parent.ResizeTxtCmd()	
	ENDPROC 
ENDDEFINE 


**************************************************
*-- Class:        my_Find 
*-- ParentClass:  container
*-- BaseClass:    container

DEFINE CLASS my_Find AS Container

	Width = 141
	Height = 135
	SpecialEffect = 2
	field = .F.
	value = .F.
	Type = 'C'


	ADD OBJECT tFind AS TextBox WITH ;
		ControlSource = "", ;
		Height = 23, ;
		Left = 2, ;
		TabIndex = 1, ;
		Top = 2, ;
		Width = 136

	ADD OBJECT ogStr AS OptionGroup WITH ;
		ButtonCount = 2, ;
		Value = 1, ;
		Height = 41, ;
		Left = 3, ;
		Top = 68, ;
		Width = 136, ;
		TabIndex = 3, ;
		Option1.BackStyle = 0, ;
		Option1.Caption = "  ", ;
		Option1.Height = 17, ;
		Option1.Left = 3, ;
		Option1.Top = 4, ;
		Option1.Width = 130, ;
		Option2.BackStyle = 0, ;
		Option2.Caption = "  ", ;
		Option2.Height = 17, ;
		Option2.Left = 3, ;
		Option2.Top = 21, ;
		Option2.Width = 130

	ADD OBJECT ogRec AS OptionGroup WITH ;
		ButtonCount = 2, ;
		Value = 1, ;
		Height = 41, ;
		Left = 3, ;
		Top = 26, ;
		Width = 136, ;
		TabIndex = 2, ;
		Option1.BackStyle = 0, ;
		Option1.Caption = "  ", ;
		Option1.Height = 17, ;
		Option1.Left = 5, ;
		Option1.Top = 4, ;
		Option1.Width = 125, ;
		Option2.BackStyle = 0, ;
		Option2.Caption = "  ", ;
		Option2.Height = 17, ;
		Option2.Left = 5, ;
		Option2.Top = 21, ;
		Option2.Width = 125

	ADD OBJECT cFind AS CommandButton WITH ;
		Top = 111, ;
		Left = 4, ;
		Height = 20, ;
		Width = 60, ;
		FontBold = .T., ;
		FontSize = 9, ;
		WordWrap = .T., ;
		Caption = "", ;
		TabIndex = 4

	ADD OBJECT cClose AS CommandButton WITH ;
		Top = 111, ;
		Left = 65, ;
		Height = 20, ;
		Width = 20, ;
		FontBold = .T., ;
		FontSize = 9, ;
		WordWrap = .T., ;
		Caption = "x", ;
		TabIndex = 5

	PROCEDURE Resize
		this.tFind.Width = this.Width - 4
	ENDPROC

	PROCEDURE SetFocus && GotFocus
	Lparameters _this
		LOCAL m.c
		WITH this
			.Top = thisform.gKLS.HeaderHeight
			.Width = _this.parent.width+4
			IF .Width<140
				.Width = 140
			ENDIF 
		
			IF OBJTOCLIENT(_this.parent.Header1,2)+.Width<thisform.Width
				.Left = OBJTOCLIENT(_this.parent.Header1,2)-2
			ELSE 				
				.Left =  OBJTOCLIENT(_this.parent.Header1,2) - (OBJTOCLIENT(_this.parent.Header1,2) + .Width - (OBJTOCLIENT(_this.parent.Header1,2) + _this.parent.Width)) + 2
			ENDIF 
			
			this.Type = Type(_this.Parent.ControlSource)
			
			IF !EMPTY(.Field) AND .Field = _this.Parent.ControlSource AND !EMPTY(.value)
				.tFind.Value = .value
			ELSE
				.Field = _this.Parent.ControlSource
				.tFind.Value = EVALUATE(_this.Parent.ControlSource)
			ENDIF 
			
			.refresh
		ENDWITH 		
		
		FOR m.c=1 TO thisform.ControlCount 
			thisform.Controls(m.c).Enabled = .f.
		ENDFOR 
		this.Enabled = .t.
		If this.Type='C'
			this.ogStr.Enabled = .t.
			this.ogStr.option1.Enabled = .t.
			this.ogStr.option2.Enabled = .t.
           		Else 
			this.ogStr.value = 1
			this.ogStr.Enabled = .f.
			this.ogStr.option1.Enabled = .f.
			this.ogStr.option2.Enabled = .f.
		EndIf 
		this.Visible = .t.
		this.tFind.SelStart = 0
		If this.Type='C'
			this.tFind.SelLength = LEN(Rtrim(TRANSFORM(this.tFind.Value)))		
		Else 
			this.tFind.SelLength = 1000
		EndIf 
	ENDPROC


	PROCEDURE tFind.KeyPress
		LPARAMETERS nKeyCode, nShiftAltCtrl
		IF nKeyCode=13 OR nKeyCode=27
			LOCAL m.c
			NODEFAULT 			
			IF nKeyCode=13
				SELECT(thisform.KLS)
				
				IF this.parent.Type='C'
					this.value = UPPER(ALLTRIM(this.Value))
				ENDIF 
				this.Parent.value = this.Value 
				
				IF this.Parent.ogRec.Value = 1
					IF this.Parent.ogStr.Value = 1
						IF !EMPTY(this.parent.Comment)
							=SEEK(this.Value)
						ELSE 
							LOCATE FOR Iif(this.parent.Type='C',Upper(EVALUATE(this.Parent.Field)),EVALUATE(this.Parent.Field))=this.Value 
						ENDIF 
					ELSE 
						LOCATE FOR AT(this.Value,UPPER(EVALUATE(this.Parent.Field)))>0
					ENDIF
				ELSE  
					DO WHILE !EOF()
						SKIP 
						IF this.Parent.ogStr.Value = 1
							IF Iif(this.parent.Type='C',Upper(EVALUATE(this.Parent.Field)),EVALUATE(this.Parent.Field))=this.Value
								EXIT 
							ENDIF 
						ELSE 
							IF AT(this.Value,UPPER(EVALUATE(this.Parent.Field)))>0
								EXIT 
							ENDIF 
						ENDIF 
					ENDDO 
				ENDIF 

				IF EOF()
					GO BOTTOM 
					this.parent.ogRec.value=1
				ENDIF 
			ENDIF 
			FOR m.c=1 TO thisform.ControlCount 
				thisform.Controls(m.c).Enabled = .t.
			ENDFOR 
			this.parent.Visible = .f.
			_rec=RECNO()
			thisform.gKLS.Refresh 
			=_GoTo(_rec)
			thisform.gKLS.SetFocus 
		ENDIF 
	EndProc

	PROCEDURE cFind.Click
		this.Parent.tFind.KeyPress(13)
	EndProc
	
	PROCEDURE cClose.Click
		this.Parent.tFind.KeyPress(27)
	ENDPROC
	
ENDDEFINE
*
*-- EndDefine: my_find
**************************************************



**************************************************
*-- Class:        TxtCmd
*-- ParentClass:  container
*-- BaseClass:    container
DEFINE CLASS TxtCmd AS container

	Width = 122
	Height = 20
	BackStyle = 0
	BorderWidth = 0
	ControlSource = "''"

	ADD OBJECT text1 AS my_text WITH ;
		TabIndex = 1, ;
		TabStop = .t. ,;
		BorderStyle = 0, ;
		Top = 0, ;
		Left = 0, ;
		Height = 20, ;
		Width = 101, ;
		SpecialEffect = 1, ;
		ReadOnly = .t., ;
		DisabledBackColor = Rgb(255,255,255)

	ADD OBJECT command1 AS commandbutton WITH ;
		TabIndex = 0, ;
		TabStop = .f. ,;
		Top = 0, ;
		Left = 101, ;
		Height = 20, ;
		Width = 20, ;
		FontBold = .T., ;
		FontSize = 12, ;
		Caption = "", ;
		SpecialEffect = 0

	PROCEDURE Command1.click
	Local _c
		_c='=comm'+this.Parent.Parent.Name+'()'
		&_c
	ENDPROC


ENDDEFINE
*
*-- EndDefine: txtcmd
**************************************************

PROCEDURE popHeaderChoices 									
	LOCAL gnCount 
	FOR gnCount = 1 TO CNTBAR('popHeader')  		    	
	   IF MRKBAR('popHeader', gnCount) = .T.      			
	      WAIT WINDOW PRMBAR('popHeader', gnCount) NOWAIT 	
	   ENDIF
	ENDFOR 
	DEACTIVATE POPUP popHeader
ENDPROC 			   


****      ****
FUNCTION AppAlreadyRunning 
	DECLARE INTEGER GetLastError IN win32API 
	DECLARE INTEGER CreateSemaphore IN WIN32API STRING @ lpSemaphoreAttributes, LONG lInitialCount, LONG lMaximumCount, STRING @ lpName 
RETURN (CreateSemaphore(0,0,1,'MESCLIENT') # 0 AND GetLastError() == 183) 
